<template>
  <div class="flex flex-wrap content-center">
    <a @click="$router.go(-1)">back</a>

    <div
      v-if="logged"
      class="w-2/4 sm:w-1/2 md:w-1/2 lg:w-1/2 xl:w-1/2 mb-4 p-5 rounded-md"
      style="margin: 2% 0% 2% 25%; background: #57575733"
    >
      <div class="w-full content-center">
        <h1 class="text-3xl m-2">Panier</h1>
        <br />

        <div
          v-for="(item, key) in cart"
          :key="key"
          class="flex items-center "
          style="width: 100%"
        >
          <div class="flex flex-wrap md:items-center mb-5">
            <div class="md:w-1/5">
              <img style="width: 100%;" :src="item.image_link" />
            </div>
            <div class="md:w-3/5" style="padding-left: 5%">
              <p
                class="text-sm font-medium text-white text-gray-300 gradient rounded-md p-1"
                style="float: right"
              >
                {{ item.photo_item.format.price }}€
              </p>
              <p class="text-sm font-medium text-white" style="float: left">
                {{ item.image_name }}
              </p>
              <br />
              <p class="text-sm font-medium text-white" style="float: left">
                {{ item.photo_item.format.label }}
              </p>
              <br />
              <p class="text-sm text-white-500" style="float:right">
                quantité : {{ item.quantity }}
              </p>
            </div>
            <div
              class="md:w-1/5 hover:text-red"
              style="padding-left: 10%; color: #d9bfbf;"
            >
              <button
                class="shadow btn_submit focus:shadow-outline focus:outline-none text-white font-bold py-2 px-4 rounded hover:bg-gray-900 hover:text-white"
                type="button"
                title="Enlever la photo du panier"
                @click="removeItem(key)"
              >
                <TrashIcon class="h-6 w-6" aria-hidden="true" />
              </button>
            </div>
          </div>
        </div>
        <button
          class="shadow btn_submit focus:shadow-outline focus:outline-none bg-gray-600 text-white font-bold py-2 px-4 rounded hover:bg-gray-900 hover:text-white"
          type="button"
          @click="pay()"
        >
          Payer
        </button>
      </div>

      <div
        v-if="success"
        class="alert-toast fixed bottom-0 right-0 m-8 w-5/6 md:w-full max-w-sm"
      >
        <input type="checkbox" class="hidden" id="footertoast" />

        <label
          class="close cursor-pointer flex items-start justify-between w-full p-2 bg-green-500 h-24 rounded shadow-lg text-white"
          title="close"
          for="footertoast"
        >
          Toast Alert (click anywhere to close)

          <svg
            class="fill-current text-white"
            xmlns="http://www.w3.org/2000/svg"
            width="18"
            height="18"
            viewBox="0 0 18 18"
          >
            <path
              d="M14.53 4.53l-1.06-1.06L9 7.94 4.53 3.47 3.47 4.53 7.94 9l-4.47 4.47 1.06 1.06L9 10.06l4.47 4.47 1.06-1.06L10.06 9z"
            ></path>
          </svg>
        </label>
      </div>
    </div>
  </div>
</template>

<script>
import { TrashIcon } from "@heroicons/vue/outline";
import emitter from "tiny-emitter/instance";
import axios from "../api/config";

export default {
  name: "Cart",
  components: {
    TrashIcon,
  },
  props: {
    msg: String,
  },
  data() {
    return {
      form: {
        user: {},
      },
      form_error: {
        user: false,
      },
      cart: {},
      counter_cart: 0,
      error: false,
      success: false,
    };
  },
  methods: {
    validate(data) {
      this.form_error.print = false;
      this.form_error.format = false;

      if (data.print == "") {
        this.form_error.print = true;
        return false;
      } else if (data.format == "") {
        this.form_error.format = true;
        return false;
      }
      return true;
    },
    setCart() {
      this.cart =
        localStorage.getItem("cart") != null
          ? JSON.parse(localStorage.getItem("cart"))
          : {};
      this.counter_cart = this.cart.length;
    },
    removeItem(key) {
      this.cart.splice(key, 1);
      localStorage.setItem("cart", JSON.stringify(this.cart));
      emitter.emit("set_cart");
    },
    pay() {
      if (this.cart.length > 0) {
        if (this.checkUserData()) {
          let items = [];
          this.cart.forEach((item) => {
            let res = {
              id: item.photo_item.id,
              quantity: item.quantity,
            };
            items.push(res);
          });

          axios
            .post("http://localhost:8888/photos_api/api/order/create", items)
            .then((res) => {
              console.log(res);
              if (res.data.result) {
                console.log(res.data);
                this.success = true;
              } else {
                this.error = res.data.error;
              }
            })
            .catch(() => {
              this.error = "Une erreur est survenue";
            });
        }
      }
    },
    checkUserData() {
      console.log("to do : check user adress + contact");
      return true;
    },
  },
  computed: {},
  async mounted() {
    this.setCart();
  },
  beforeCreate() {
    this.logged = localStorage.getItem("is_logged") == "true" ? true : false;
  },
};
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped>
.image {
  width: 100%;
  padding: 3%;
}
</style>
